Bug 87863 - socket leak
Summary: socket leak
Status: CLOSED ERRATA
Alias: None
Product: Red Hat Linux
Classification: Retired
Component: xinetd (Show other bugs)
(Show other bugs)
Version: 7.3
Hardware: All Linux
low
medium
Target Milestone: ---
Assignee: Jay Fenlason
QA Contact: Brock Organ
URL:
Whiteboard:
Keywords: Security
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2003-04-03 11:28 UTC by Kasper Dupont
Modified: 2014-08-31 23:24 UTC (History)
1 user (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2003-05-13 17:14:05 UTC
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)


External Trackers
Tracker ID Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2003:160 normal SHIPPED_LIVE : Updated xinetd packages fix a denial-of-service attack and other bugs 2003-05-13 04:00:00 UTC
Red Hat Product Errata RHSA-2003:161 normal SHIPPED_LIVE Important: xinetd security update 2003-05-22 04:00:00 UTC

Description Kasper Dupont 2003-04-03 11:28:45 UTC
Description of problem:
If fork() fails xinetd will leak sockets.
Leaked sockets will be inherited by child processes.

Version-Release number of selected component (if applicable):
xinetd-2.3.7-4.7x

How reproducible:
Easy to reproduce if compiled with the DEBUG_RETRY
option. Otherwise hard to reproduce.

Steps to Reproduce:
1. Compile xinetd with the DEBUG_RETRY option
2. Install xinetd and enable telnet
3. Open a lot of incomming telnet sessions
    
Actual results:
xinetd leaks filedescriptors and eventually stops
accepting connections. Child processes inherit the
leaked descriptors. (In case of telnet the child
will close the descriptor, so this is not immediately
exploitable by arbitrary users.)

Expected results:
On fork failing xinetd closes the connection
before going back to accept more connections.

Additional info:
Severity set to security, because xinetd services not
running as root could potentially take over the leaked
descriptors and snoop passwords. Priority set to low
because the default install is not believed to be
exploitable.

Comment 1 Mark J. Cox 2003-05-01 15:10:46 UTC
xinetd update (to 2.3.11) is in progress.

Comment 2 Mark J. Cox 2003-05-13 17:14:05 UTC
An errata has been issued which should help the problem described in this bug report. 
This report is therefore being closed with a resolution of ERRATA. For more information
on the solution and/or where to find the updated files, please follow the link below. You may reopen 
this bug report if the solution does not work for you.

http://rhn.redhat.com/errata/RHSA-2003-160.html



Note You need to log in before you can comment on or make changes to this bug.